using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using DDRHelper.Services;

namespace DDRHelper
{
    public static class Helpers
    {
        /*
         * Helpers is a simple class designed to wrap some complex functions into simple ones,
         * or otherwise protect parts of the program.
         */

        public static Icon getIconResource(String IconName)
        {
            return new Icon(Program.servicesAssembly.GetManifestResourceStream(IconName));
        }

        public static void showPluginAboutDialogue(String PluginName, String PluginVersion, String PluginAuthor)
        {
            showPluginAboutDialogue(PluginName, PluginVersion, PluginAuthor, DDRService.SERVICE_PLUGIN_ICON);
        }

        public static void showPluginAboutDialogue(String PluginName, String PluginVersion, String PluginAuthor, Icon PluginIcon)
        {
            MessageBox.Show(PluginName + " Plugin, version " + PluginVersion + ", written by " + PluginAuthor + ".");
        }

        public static String generateClassNameFromService(String ServiceName)
        {
            if (ServiceName.Length > 0)
            {
                int x;
                bool NextCharacterUpCase = true;
                ServiceName = ServiceName.Trim();
                char[] ClassNameCA = ServiceName.ToCharArray();
                String ClassName = "";

                for (x = 0; x < ServiceName.Length; x++)
                {
                    if (ClassNameCA.GetValue(x).ToString() == " ")
                    {
                        NextCharacterUpCase = true;
                    }
                    else
                    {
                        if (NextCharacterUpCase)
                        {
                            ClassName = ClassName + ClassNameCA.GetValue(x).ToString().ToUpperInvariant();
                            NextCharacterUpCase = false;
                        }
                        else
                        {
                            ClassName = ClassName + ClassNameCA.GetValue(x).ToString();
                        }
                    }
                }

                return ClassName + "Service";
            }
            else
            {
                return "";
            }
        }
    }
}
