/*
 * Before we start, we need to compile all of our Services.  This allows a user to add in new
 * services without needing to recompile the app.
 * 
 * This will generate Services.dll from the directory /Services/*.cs
 * 
 * References:
 *  - http://www.codeproject.com/useritems/Run-Time_Code_Generation1.asp
 */
using System;
using System.IO;
using System.Text;
using Microsoft.CSharp;
using System.CodeDom.Compiler;

namespace DDRHelper
{
    class Main
    {
        public static void main(String[] args)
        {
            // start GUI
            Form1 frm = new Form1();
            frm.Show();

        }

        public static void CompileCode()
        {
            // compile code...
            CSharpCodeProvider cscp = new CSharpCodeProvider();
            
            CompilerParameters ccp = new CompilerParameters();
            ccp.GenerateExecutable = false;
            ccp.GenerateInMemory = true;
            ccp.ReferencedAssemblies.Add("System.dll");
            ccp.ReferencedAssemblies.Add("DDRHelper.exe");

            DirectoryInfo dir = new DirectoryInfo("./Services/");
            
            String[] sources = new String[dir.GetFiles("*.cs").Length];
            int i = 0;
            foreach (FileInfo f in dir.GetFiles("*.cs")) {
                sources[i] = f.Name;
                i++;
            }

            CompilerResults cr = cscp.CompileAssemblyFromFile(ccp, sources);
            if (cr.Errors.Count > 0)
            {
                // Display compilation errors.
                Console.WriteLine("Errors building Services.");
                foreach (CompilerError ce in cr.Errors)
                {
                    Console.WriteLine("  {0}", ce.ToString());
                    Console.WriteLine();
                }
                throw new Exception("Code compilation failure!");
            }
        }

    }
}
