using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using DDRHelper.Services;

namespace DDRHelper
{
    public partial class ScriptsViewer : Form
    {
        private Type[] plugins;
        public ScriptsViewer()
        {
            InitializeComponent();
            PopulatePluginList();
        }

        private void PopulatePluginList()
        {
            PluginSelector.Clear();
            plugins = Program.servicesAssembly.GetTypes();
            //il.Images.Add("0", System.Drawing.SystemIcons.Application);
            ListViewItem lvi;
            int x = 0;
            Icon icon;
            foreach (Type plugin in plugins)
            {
                lvi = new ListViewItem((String)plugin.InvokeMember("SERVICE_PLUGIN_NAME", BindingFlags.Public | BindingFlags.GetField | BindingFlags.Static, null, null, null), x.ToString());
                icon = ((Icon)plugin.InvokeMember("SERVICE_PLUGIN_ICON", BindingFlags.Public | BindingFlags.GetField | BindingFlags.Static, null, null, null));
                if (icon == null) {
                    icon = DDRService.SERVICE_PLUGIN_ICON;
                }
                il.Images.Add(x.ToString(), icon.ToBitmap());
                PluginSelector.Items.Add(lvi);
                x++;
            }
        }

        private void aboutThisPluginToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (PluginSelector.SelectedItems.Count == 1)
            {
                try
                {
                    plugins[PluginSelector.SelectedItems[0].Index].InvokeMember("showAboutDialogue", BindingFlags.Public | BindingFlags.InvokeMethod | BindingFlags.Static, null, null, null);
                }
                catch (Exception ex)
                {
                    ex.ToString();
                    DDRService.showAboutDialogue();
                }
            }
            else
            {
                MessageBox.Show("You must select an item first.");
            }

        }

        private void PluginSelectorContextMenu_Opening(object sender, CancelEventArgs e)
        {
            if (PluginSelector.SelectedItems.Count != 1)
            {
                MessageBox.Show("You must select an item first.");
                e.Cancel = true;
            }
        }

        private void visitThisPluginsWebsiteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (PluginSelector.SelectedItems.Count == 1)
            {
                try
                {
                    MessageBox.Show("Not written yet.");
                    //plugins[PluginSelector.SelectedItems[0].Index].InvokeMember("showAboutDialogue", BindingFlags.Public | BindingFlags.InvokeMethod | BindingFlags.Static, null, null, null);
                }
                catch (Exception ex)
                {
                    ex.ToString();
                    //DDRService.showAboutDialogue();
                }
            }
            else
            {
                MessageBox.Show("You must select an item first.");
            }
        }

    }
}