/*
 * CallOfDutyService.cs - Call of Duty
 * Category: Games/First Person Shooters
 */

using System;
using System.Text;
using System.Drawing;
using DDRHelper.Properties;

namespace DDRHelper.Services
{
    public class CallOfDutyService : UDPService
    {
        public static new Icon SERVICE_PLUGIN_ICON = Helpers.getIconResource("CallOfDutyService.ico");
        public static new String SERVICE_PLUGIN_NAME = "Call of Duty Service";
        public static new String SERVICE_PLUGIN_VERSION = "1.0";
        public static new String SERVICE_PLUGIN_AUTHOR = "Michael Farrell";
        public static new Uri SERVICE_PLUGIN_URI = new Uri("http://lz129.concreteairship.com/projects/ddrgen/");
        public static new int SERVICE_DEFAULT_PORT = 28960;
        public static new String SERVICE_CATEGORY = "Games";
        public static new String SERVICE_SUBCATEGORY = "First Person Shooters";        

        public CallOfDutyService() : this("Default Call of Duty Server", "", SERVICE_DEFAULT_PORT)
        {
        }

        public CallOfDutyService(String ServiceName, String ServiceDescription, int ServicePort)
            : base(ServiceName, ServicePort, ServiceDescription, "CoD")
        {
            this.DefaultPort = SERVICE_DEFAULT_PORT;
        }

        protected override void InitProperties()
        {
            Properties.Add(new ServicePropertyString("Password", ""));
            Properties.Add(new ServicePropertyString("Game Type", "Deathmatch"));
            Properties.Add(new ServicePropertyString("Map", "mp_kharkov"));
        }

        public override Uri getResourceUri(String address)
        {
            return new System.Uri("cod://" + address + ":" + this.ServicePort);
        }

        public static new void showAboutDialogue()
        {
            Helpers.showPluginAboutDialogue(SERVICE_PLUGIN_NAME, SERVICE_PLUGIN_VERSION, SERVICE_PLUGIN_AUTHOR, SERVICE_PLUGIN_ICON);
        }
    }
}
