/*
 * CounterStrikeService.cs - CounterStrike (<=1.6)
 * Category: Games/First Person Shooters
 */

using System;
using System.Text;
using System.Drawing;
using DDRHelper.Properties;

namespace DDRHelper.Services
{
    public class CounterStrikeService : UDPService
    {
        public static new Icon SERVICE_PLUGIN_ICON = Helpers.getIconResource("CounterStrikeSourceService.ico");
        public static new String SERVICE_PLUGIN_NAME = "CounterStrike Service";
        public static new String SERVICE_PLUGIN_VERSION = "1.0";
        public static new String SERVICE_PLUGIN_AUTHOR = "Michael Farrell";
        public static new Uri SERVICE_PLUGIN_URI = new Uri("http://lz129.concreteairship.com/projects/ddrgen/");
        public static new int SERVICE_DEFAULT_PORT = 27015;
        public static new String SERVICE_CATEGORY = "Games";
        public static new String SERVICE_SUBCATEGORY = "First Person Shooters";

        public CounterStrikeService()
            : this("Default CounterStrike Source Server", "", SERVICE_DEFAULT_PORT)
        {
        }

        public CounterStrikeService(String ServiceName, String ServiceDescription, int ServicePort)
            : base(ServiceName, ServicePort, ServiceDescription, "CS")
        {
            this.DefaultPort = SERVICE_DEFAULT_PORT;
        }

        protected override void InitProperties()
        {
            Properties.Add(new ServicePropertyString("Password", ""));
            Properties.Add(new ServicePropertyString("Game Type", "CounterStrike"));
            Properties.Add(new ServicePropertyString("Map", "cs_italy"));
        }

        public override Uri getResourceUri(String address)
        {
            return new System.Uri("cs://" + address + ":" + this.ServicePort);
        }

        public static new void showAboutDialogue()
        {
            Helpers.showPluginAboutDialogue(SERVICE_PLUGIN_NAME, SERVICE_PLUGIN_VERSION, SERVICE_PLUGIN_AUTHOR, SERVICE_PLUGIN_ICON);
        }
    }
}
