/*
 * FTPService.cs - File Transfer Protocol
 * Category: Servers/File Transfer
 */

using System;
using System.Text;
using System.Drawing;
using DDRHelper.Properties;

namespace DDRHelper.Services
{
    public class FTPService : TCPService
    {
        public static new Icon SERVICE_PLUGIN_ICON = null;
        public static new String SERVICE_PLUGIN_NAME = "FTP Service";
        public static new String SERVICE_PLUGIN_VERSION = "1.0";
        public static new String SERVICE_PLUGIN_AUTHOR = "Michael Farrell";
        public static new Uri SERVICE_PLUGIN_URI = new Uri("http://lz129.concreteairship.com/projects/ddrgen/");
        public static new int SERVICE_DEFAULT_PORT = 21;
        public static new String SERVICE_CATEGORY = "Servers";
        public static new String SERVICE_SUBCATEGORY = "File Transfer";

        public FTPService() : this("Default FTP Server", "", SERVICE_DEFAULT_PORT)
        {
        }

        public FTPService(String ServiceName, String ServiceDescription, int ServicePort)
            : base(ServiceName, ServicePort, ServiceDescription, "FTP")
        {
            this.DefaultPort = SERVICE_DEFAULT_PORT;
        }

        protected override void InitProperties()
        {
            Properties.Add(new ServicePropertyString("Path", "/"));
            Properties.Add(new ServicePropertyString("Username", ""));
            Properties.Add(new ServicePropertyString("Password", ""));
        }


        public override Uri getResourceUri(String address)
        {
            if (((String)this.getPropertyLabel("Username").getValue()).Length == 0)
            {
                return new System.Uri("ftp://" + address + ":" + this.ServicePort + "/" + this.getPropertyLabel("Path").getValue());
            }
            else
            {
                return new System.Uri("ftp://" + this.getPropertyLabel("Username").getValue() + ":" + this.getPropertyLabel("Password").getValue() + "@" + address + ":" + this.ServicePort + "/" + this.getPropertyLabel("Path").getValue());
            }
        }

        public static new void showAboutDialogue()
        {
            Helpers.showPluginAboutDialogue(SERVICE_PLUGIN_NAME, SERVICE_PLUGIN_VERSION, SERVICE_PLUGIN_AUTHOR);
        }
    }
}
