/*
 * RTCWEnemyTerritoryService.cs - Return to the Castle of Wolfenstein: Enemy Territory
 * Category: Games/First Person Shooters
 */

using System;
using System.Text;
using System.Drawing;
using DDRHelper.Properties;

namespace DDRHelper.Services
{
    public class RTCWEnemyTerritoryService : UDPService
    {
        public static new Icon SERVICE_PLUGIN_ICON = Helpers.getIconResource("RTCWEnemyTerritoryService.ico");
        public static new String SERVICE_PLUGIN_NAME = "RTCW: Enemy Territory Service";
        public static new String SERVICE_PLUGIN_VERSION = "1.0";
        public static new String SERVICE_PLUGIN_AUTHOR = "Michael Farrell";
        public static new Uri SERVICE_PLUGIN_URI = new Uri("http://lz129.concreteairship.com/projects/ddrgen/");
        public static new int SERVICE_DEFAULT_PORT = 27960;
        public static new String SERVICE_CATEGORY = "Games";
        public static new String SERVICE_SUBCATEGORY = "First Person Shooters";
        
        public RTCWEnemyTerritoryService()
            : this("Default RTCW: Enemy Territory Server", "", SERVICE_DEFAULT_PORT)
        {
        }

        public RTCWEnemyTerritoryService(String ServiceName, String ServiceDescription, int ServicePort)
            : base(ServiceName, ServicePort, ServiceDescription, "ET")
        {
            this.DefaultPort = SERVICE_DEFAULT_PORT;
        }

        protected override void InitProperties()
        {
            Properties.Add(new ServicePropertyString("Password", ""));
            Properties.Add(new ServicePropertyString("Game Type", "Objective"));
            Properties.Add(new ServicePropertyString("Map", "6-Map"));
			Properties.Add(new ServicePropertyString("Mod", "etpub"));
        }

        public override Uri getResourceUri(String address)
        {
            return new System.Uri("et://" + address + ":" + this.ServicePort);
        }

        public static new void showAboutDialogue()
        {
            Helpers.showPluginAboutDialogue(SERVICE_PLUGIN_NAME, SERVICE_PLUGIN_VERSION, SERVICE_PLUGIN_AUTHOR, SERVICE_PLUGIN_ICON);
        }
    }
}
