using System;
using System.Threading;
using MiniHttpd;


namespace DDRHelper
{
    class TalkBackComponent
    {
        ///<summary>
        /// TalkBackComponent is a simple wrapper that launches a
        /// MiniHttpd.HttpWebServer with a virtualised filesystem.  As of ddrhelper
        /// 0.9.2 that is the standard web server system, rather than HTTPListener, due
        /// to lack of platform support on Windows 2000.
        ///</summary>

        // Define default port for ddrhelper to listen on
        public static int SERVER_PORT = 6565;
        private static Thread initThread;
        private static HttpWebServer server;

        public static bool CheckServerSupport()
        {
            return true;
            //return HttpListener.IsSupported;
        }


        public static void StartServerBackground()
        {
            //if (!CheckServerSupport())
            //{
            //    Console.WriteLine("Cannot start server component, requires Windows XP SP2, or Windows 2003 Server.");
            //    throw new PlatformNotSupportedException("Windows XP SP2 or Windows 2003 Server is required for this program to run.");
            //}
            // This is where we start the server in the background
            initThread = new Thread(new ThreadStart(StartServer));
            initThread.SetApartmentState(ApartmentState.STA);
            initThread.Start();
            Console.WriteLine("Spawned TalkBackComponent.StartServer!");
        }

        private static void StartServer()
        {
            server = new HttpWebServer(TalkBackComponent.SERVER_PORT);
            VirtualDirectory root = new VirtualDirectory();
            server.Root = root;
            root.AddFile(new TalkBackPages.HomePage("index.html", root));
            root.AddFile(new TalkBackPages.Stylesheet("style.css", root));
            root.AddFile(new TalkBackPages.ConfigurationDump("svs", root));
            root.AddFile(new TalkBackPages.FavouritesIcon("favicon.ico", root));
            root.AddDirectory(new TalkBackPages.ServiceInfoDirectory("info", root));
            root.AddDirectory(new TalkBackPages.ServiceIconDirectory("icon", root));

            // start server.
            server.Start();

            Console.WriteLine("Web server started ok!");
        }
        
        public static void StopServer()
        {
            initThread.Abort();
            server.Stop();
        }

    }
}
