using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using DDRHelper;
using MiniHttpd;

namespace DDRHelper.TalkBackPages
{
    class ConfigurationDump : IFile
    {

        public ConfigurationDump(string name, IDirectory parent)
        {
            this.name = name;
            this.parent = parent;
        }

        string name;
        IDirectory parent;

        public void OnFileRequested(HttpRequest request,
                                    IDirectory directory)
        {
            // Assign a MemoryStream to hold the response content.
            request.Response.ResponseContent = new MemoryStream();

            // Create a StreamWriter to which we
            // can write some text, and write to it.
            StreamWriter writer =
              new StreamWriter(request.Response.ResponseContent);

            writer.Write(Program.config.dumpConfiguration(request.Uri.Host));
            // Don't forget to flush!
            writer.Flush();
        }

        public string ContentType
        {
            get { return ContentTypes.GetExtensionType(".txt"); }
        }
        public string Name
        {
            get { return name; }
        }

        public IDirectory Parent
        {
            get { return parent; }
        }

        public void Dispose()
        {
        }
    }
}
