
using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using MiniHttpd;
using DDRHelper;
using DDRHelper.Services;

namespace DDRHelper.TalkBackPages
{
    class Stylesheet:IFile
    {
        public Stylesheet(string name, IDirectory parent)
        {
            this.name = name;
            this.parent = parent;
        }

        string name;
        IDirectory parent;

        public void OnFileRequested(HttpRequest request,
                                    IDirectory directory)
        {
            // Assign a MemoryStream to hold the response content.
            request.Response.ResponseContent = new MemoryStream();

            // Create a StreamWriter to which we
            // can write some text, and write to it.
            StreamWriter writer =
                    new StreamWriter(request.Response.ResponseContent);
            writer.WriteLine(
                    "body { background: #000; color: #0f0; } \r\n" +
                    "a { color: #44f; text-decoration: none; } \r\n" +
                    "a:hover { background: #44f; color: #000; text-decoration: none; } \r\n" +
                    "table { border: #040 1px solid; width: 100%; } \r\n" +
                    "td { border: #040 1px solid; background-color: #020; } \r\n" +
                    "td.c { text-align: center; background-color: #000; } \r\n" +
                    "td.n { background-color: #002; } \r\n");

            // Don't forget to flush!
            writer.Flush();
        }

        public string ContentType
        {
            get { return ContentTypes.GetExtensionType(".css"); }
        }
        public string Name
        {
            get { return name; }
        }

        public IDirectory Parent
        {
            get { return parent; }
        }

        public void Dispose()
        {
        }
    }
 
}

